package prompt.multiperspective.configuration.gui;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import java.awt.Dimension;
import java.util.Arrays;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.framework.util.ui.widgets.ProMList;

import prompt.multiperspective.configuration.MultiperspectiveConfiguration;
import prompt.multiperspective.configuration.MultiperspectiveConfiguration.CONTROL_FLOW_MINER;


/**
 * A panel for the control-flow miner selection
 * 
 * @author Anna Kalenkova
 *
 */
public class SelectMiner extends JPanel {

	private static final long serialVersionUID = 3232985242411989559L;

	public SelectMiner(final MultiperspectiveConfiguration configuration) {
		double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL } };
		setLayout(new TableLayout(size));

		setOpaque(false);
		
		DefaultListModel<String> listModel = new DefaultListModel<String>();
		for (CONTROL_FLOW_MINER miner: Arrays.asList(CONTROL_FLOW_MINER.values())) {
			listModel.addElement(miner.toString());
		}
		final ProMList<String> list = new ProMList<String>("Select control-flow miner", listModel);
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				List<String> selected = list.getSelectedValuesList();
				if (selected.size() == 1) {
					configuration.setControlFlowMiner(CONTROL_FLOW_MINER.getValueByText(selected.get(0)));
				} else {
					/*
					 * Nothing selected. Revert to selection of default classifier.
					 */
					list.setSelectedIndex(0);
					configuration.setControlFlowMiner(CONTROL_FLOW_MINER
							.valueOf(list.getSelectedValuesList().get(0)));
				}
			}
		});
		list.setPreferredSize(new Dimension(100, 100));
		add(list, "0, 0");
	}
}
