package prompt.multiperspective.configuration.gui;

import java.awt.BorderLayout;

import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;

import prompt.multiperspective.utils.GUIUtils;

import com.fluxicon.slickerbox.factory.SlickerFactory;
import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.layout.FormLayout;

/**
 * 
 * @author Andrea Burattin
 */
public class SimpleConfiguration extends JPanel {

	private static final long serialVersionUID = -274338207158410851L;
	private JSlider fitnessSlider = SlickerFactory.instance().createSlider(JSlider.HORIZONTAL);

	public SimpleConfiguration() {
		init();
	}
	
	private void init() {
		fitnessSlider.setMinimum(0);
		fitnessSlider.setMaximum(1000);
		fitnessSlider.setValue(200);
		
		FormLayout layout = new FormLayout("fill:pref:grow, 2dlu, fill:pref:grow");
		DefaultFormBuilder builder = new DefaultFormBuilder(layout);
		
		GUIUtils.configureSeparator(builder.appendSeparator("Simple Configuration"));
		builder.append(Box.createVerticalStrut(10), 3);
		builder.append(GUIUtils.fromHTMLToJLabel("simple-configuration.html"), 3);
		builder.append(Box.createVerticalStrut(20), 3);
		builder.append(fitnessSlider, 3);
		builder.append(new JLabel("Model more coherent with the log"));
		builder.append(new JLabel("More abstract model", JLabel.RIGHT));
		
		setLayout(new BorderLayout());
		add(builder.getPanel());
	}
	
	public float getFitness() {
		return ((float) fitnessSlider.getValue()) / 1000f;
	}
}
