//package prompt.multiperspective.plugins;
//
//import java.util.HashMap;
//import java.util.HashSet;
//import java.util.Iterator;
//import java.util.Map;
//import java.util.Set;
//
//import org.processmining.contexts.uitopia.UIPluginContext;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.loclog.utils.BPMNUtils;
//import org.processmining.models.connections.petrinets.behavioral.InitialMarkingConnection;
//import org.processmining.models.graphbased.directed.bpmn.BPMNDiagram;
//import org.processmining.models.graphbased.directed.bpmn.elements.Activity;
//import org.processmining.models.graphbased.directed.bpmn.elements.Flow;
//import org.processmining.models.graphbased.directed.bpmn.elements.TextAnnotation;
//import org.processmining.models.graphbased.directed.petrinet.Petrinet;
//import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
//import org.processmining.models.graphbased.directed.petrinet.elements.Place;
//import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
//import org.processmining.models.semantics.petrinet.Marking;
//import org.processmining.plugins.bpmn.BpmnAssociation.AssociationDirection;
//import org.processmining.plugins.converters.BPMNConversionConnection;
//import org.processmining.plugins.petrinet.replayresult.PNRepResult;
//import org.processmining.plugins.petrinet.replayresult.StepTypes;
//import org.processmining.plugins.replayer.replayresult.SyncReplayResult;
//
//import prompt.bpmn.visualizer.ActivityDecorator;
//import prompt.bpmn.visualizer.Decorator;
//import prompt.bpmn.visualizer.FlowDecorator;
//import prompt.multiperspective.utils.AuthorsInfo;
//import prompt.multiperspective.utils.PluginNames;
//
//public class ModelEnhancer {
//
//	class LogModelMoves {
//		public long logModelGood;
//		public long logModelNoGood;
//		public long logOnly;
//		public long modelOnly;
//	}
//	
//	@SuppressWarnings("unchecked")
//	@Plugin(
//			name = PluginNames.MODEL_ENHANCER,
//			parameterLabels = { "BPMN Model", "Petri net", "Replay result"},
//			returnLabels = { "BPMN Model" },
//			returnTypes = { BPMNDiagram.class },
//			userAccessible = true
//		)
//		@UITopiaVariant(
//			author = AuthorsInfo.AUTHOR,
//			email = AuthorsInfo.EMAIL,
//			affiliation = AuthorsInfo.AFFILIATION
//		)
//		public static BPMNDiagram plugin(UIPluginContext context, BPMNDiagram diagram, Petrinet petriNet, PNRepResult replayResult) {
//		try {	
//			Map<String, Activity> transitionConversionMap = context.tryToFindOrConstructFirstObject(Map.class,
//						BPMNConversionConnection.class, BPMNConversionConnection.TRANSITION_CONVERSION_MAP, petriNet);
//			Map<Place, Flow> placeConversionMap = context.tryToFindOrConstructFirstObject(Map.class,
//					BPMNConversionConnection.class, BPMNConversionConnection.PLACE_CONVERSION_MAP, petriNet);
//				Map<String, LogModelMoves> activitiesMoves = new HashMap<String, LogModelMoves>();
//				Map<String, LogModelMoves> flowsMoves = new HashMap<String, LogModelMoves>();
//				
//				// Calculate asynch moves
//				InitialMarkingConnection initialMarkingConnection = context.getConnectionManager().getFirstConnection(
//						InitialMarkingConnection.class, context, petriNet);
//				Marking initMarking = initialMarkingConnection.getObjectWithRole(InitialMarkingConnection.MARKING);
//				Iterator<SyncReplayResult> iterator = replayResult.iterator();
//
//				while(iterator.hasNext()) {
//					SyncReplayResult res = iterator.next();
//					int nodeNumber = 0;
//					Marking currentMarking = initMarking;
//					for (StepTypes stepType : res.getStepTypes()) {
//						fireDummyTransitions(petriNet, currentMarking);
//						Object node = res.getNodeInstance().get(nodeNumber);
//						if (node instanceof Transition) {
//							fireTransition((Transition)node, petriNet, currentMarking);
//							Activity activity = transitionConversionMap.get(((Transition) node).getId().toString());
//							if (activity != null) {
//								if(activitiesMoves.get(activity.getLabel()) == null) {
//									activitiesMoves.put(activity.getLabel(), new ModelEnhancer().new LogModelMoves());
//								}
//								switch (stepType) {
//									case LMGOOD:
//										activitiesMoves.get(activity.getLabel()).logModelGood++;
//										break;
//									case LMNOGOOD:
//										activitiesMoves.get(activity.getLabel()).logModelNoGood++;
//										break;
//									case L:
//										activitiesMoves.get(activity.getLabel()).logOnly++;
//										break;
//									case MREAL:
//										activitiesMoves.get(activity.getLabel()).modelOnly++;
//										break;
//									default :
//										break;
//								}
//							}
//						}
//						for(Place place : currentMarking) {
//							Flow flow = placeConversionMap.get(place);
//							if (flow != null) {
//								if(flowsMoves.get(flow.getEdgeID().toString()) == null) {
//									flowsMoves.put(flow.getEdgeID().toString(), new ModelEnhancer().new LogModelMoves());
//								}
//								switch (stepType) {
//									case LMGOOD:
//										flowsMoves.get(flow.getEdgeID().toString()).logModelGood++;
//										break;
//									case LMNOGOOD:
//										flowsMoves.get(flow.getEdgeID().toString()).logModelNoGood++;
//										break;
//									case L:
//										flowsMoves.get(flow.getEdgeID().toString()).logOnly++;
//										break;
//									case MREAL:
//										flowsMoves.get(flow.getEdgeID().toString()).modelOnly++;
//										break;
//									default :
//										break;
//								}
//							}
//						}
//						nodeNumber++;
//					}
//				}
//				// Enhance a diagram
//				for(Activity activity : diagram.getActivities()) {
//					LogModelMoves activityMoves = activitiesMoves.get(activity.getLabel());
//					if(activityMoves != null) {
//						TextAnnotation a = diagram.addTextAnnotation("");
//						ActivityDecorator conformDecorator = 
//								new ActivityDecorator(a);
//						conformDecorator.setAttribute(Decorator.Fields.MOVE_BOTH_CORRECT, 
//								activityMoves.logModelGood);
//						conformDecorator.setAttribute(Decorator.Fields.MOVE_BOTH_INCORRECT, 
//								activityMoves.logModelNoGood);
//						conformDecorator.setAttribute(Decorator.Fields.MOVE_LOG, 
//								activityMoves.logOnly);
//						conformDecorator.setAttribute(Decorator.Fields.MOVE_MODEL, 
//								activityMoves.modelOnly);
//						diagram.addAssociation(activity, conformDecorator, AssociationDirection.NONE);						
//					}
//				}
//				for(Flow flow : diagram.getFlows()) {
//					LogModelMoves flowMoves = flowsMoves.get(flow.getEdgeID().toString());
//					if(flowMoves != null) {
//						TextAnnotation a = diagram.addTextAnnotation("");
//						FlowDecorator flowDecorator = 
//								new FlowDecorator(a);
//						flowDecorator.setFlow(flow);
//						flowDecorator.setAttribute(Decorator.Fields.MOVE_BOTH_CORRECT, 
//								flowMoves.logModelGood);
//						flowDecorator.setAttribute(Decorator.Fields.MOVE_BOTH_INCORRECT, 
//								flowMoves.logModelNoGood);
//						flowDecorator.setAttribute(Decorator.Fields.MOVE_LOG, 
//								flowMoves.logOnly);
//						flowDecorator.setAttribute(Decorator.Fields.MOVE_MODEL, 
//								flowMoves.modelOnly);
//						diagram.addAssociation(diagram.getActivities().iterator().next(),
//								flowDecorator, AssociationDirection.NONE);	
//					}
//				}
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//			return diagram;
//		}
//	
//	private static void fireDummyTransitions (Petrinet petriNet, Marking currentMarking) {
//		for(Transition transition : petriNet.getTransitions()) {
//			if(transition.getLabel().startsWith((BPMNUtils.START_SUBPROCESS_PREFIX)) 
//					|| transition.getLabel().startsWith((BPMNUtils.END_SUBPROCESS_PREFIX))) {
//				Set<Place> inPlaces = new HashSet<Place>();
//				for(PetrinetEdge edge : petriNet.getInEdges(transition)) {
//					inPlaces.add((Place)edge.getSource());
//				}
//				boolean isEnabled = true;
//				for(Place inPlace : inPlaces) {
//					if(!currentMarking.contains(inPlace)) {
//						isEnabled = false;
//					}
//				}
//				if(isEnabled) {
//					fireTransition(transition, petriNet, currentMarking);
//				}
//			}
//		}
//	}
//	
//	private static void fireTransition(Transition transition, Petrinet petriNet, Marking marking) {
//		for(PetrinetEdge edge : petriNet.getInEdges(transition)) {
//			Place inPlace = (Place)edge.getSource();
//			if(marking.contains(inPlace)) {
//				marking.remove(inPlace);
//			}
//		}
//		for(PetrinetEdge edge : petriNet.getOutEdges(transition)) {
//			Place outPlace = (Place)edge.getTarget();
//			marking.add(outPlace);
//		}
//	}
//}
