package prompt.multiperspective.utils;

import java.util.Collection;
import java.util.Collections;

import org.deckfour.uitopia.api.model.ResourceType;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.model.ProMPOResource;
import org.processmining.contexts.uitopia.model.ProMResource;
import org.processmining.framework.providedobjects.ProvidedObjectID;

/**
 * 
 * @author Andrea Burattin
 */
public class ContextUtils {

	/**
	 * 
	 * @param context
	 * @param object
	 * @param name
	 * @return
	 */
	public static ProMResource<?> addToContext(UIPluginContext context, Object object, String name) {
		ProvidedObjectID petriObjId = context.getProvidedObjectManager().createProvidedObject(name, object, context);
		
		ResourceType resType = context.getGlobalContext().getResourceManager().getResourceTypeFor(object.getClass());
		if (resType != null) {
			ProMResource<?> res = new ProMPOResource(context.getGlobalContext(), null, resType, petriObjId, Collections.<Collection<ProMPOResource>>emptyList());
			context.getGlobalContext().getResourceManager().addResource(petriObjId, res);
			return res;
		}
		return null;
	}
}
